'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var styled = require('styled-components');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var styled__default = /*#__PURE__*/_interopDefaultLegacy(styled);

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

function __makeTemplateObject(cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
}

var px2rem = function (px) { return px / 16 + "rem"; };

var StyledButton = styled__default['default'].button(templateObject_1$6 || (templateObject_1$6 = __makeTemplateObject(["\n  background: #333;\n  color: #fff;\n  font-size: 20px;\n  border: none;\n  padding: 10px 20px;\n  ", "\n  ", "\n  ", "\n  ", "\n"], ["\n  background: #333;\n  color: #fff;\n  font-size: 20px;\n  border: none;\n  padding: 10px 20px;\n  ", "\n  ", "\n  ", "\n  ", "\n"])), function (_a) {
    var borderRadius = _a.borderRadius;
    return borderRadius && "border-radius: " + borderRadius + "px;";
}, function (_a) {
    var background = _a.background;
    return background && "background: " + background + ";";
}, function (_a) {
    var fontSize = _a.fontSize;
    return fontSize && "font-size: " + px2rem(fontSize) + ";";
}, function (_a) {
    var padding = _a.padding;
    return padding && "padding: " + padding + ";";
});
var Button = function (_a) {
    var text = _a.text, borderRadius = _a.borderRadius, background = _a.background, fontSize = _a.fontSize, padding = _a.padding;
    return (React__default['default'].createElement(StyledButton, { role: "button", borderRadius: borderRadius, background: background, fontSize: fontSize, padding: padding, "data-testid": "button" }, text));
};
var templateObject_1$6;

var size = {
    mobileS: "320px",
    mobileM: "375px",
    mobileL: "425px",
    tablet: "768px",
    laptop: "1024px",
    laptopL: "1440px",
    desktop: "2560px",
};
var device = {
    mobileS: "(min-width: " + size.mobileS + ")",
    mobileM: "(min-width: " + size.mobileM + ")",
    mobileL: "(min-width: " + size.mobileL + ")",
    tablet: "(min-width: " + size.tablet + ")",
    laptop: "(min-width: " + size.laptop + ")",
    laptopL: "(min-width: " + size.laptopL + ")",
    desktop: "(min-width: " + size.desktop + ")",
    desktopL: "(min-width: " + size.desktop + ")",
};

var StyledContainer = styled__default['default'].div(templateObject_1$5 || (templateObject_1$5 = __makeTemplateObject(["\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  @media ", " {\n    ", ";\n  }\n"], ["\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  @media ", " {\n    ", ";\n  }\n"])), function (_a) {
    var padding = _a.padding;
    return padding && "padding: " + px2rem(padding) + ";";
}, function (_a) {
    var paddingLeft = _a.paddingLeft;
    return paddingLeft && "padding-left: " + px2rem(paddingLeft) + ";";
}, function (_a) {
    var paddingRight = _a.paddingRight;
    return paddingRight && "padding-right: " + px2rem(paddingRight) + ";";
}, function (_a) {
    var backgroundColor = _a.backgroundColor;
    return backgroundColor && "background-color: " + backgroundColor + ";";
}, function (_a) {
    var color = _a.color;
    return color && "color: " + color + ";";
}, function (_a) {
    var width = _a.width;
    return width && "width: " + width + ";";
}, function (_a) {
    var height = _a.height;
    return height && "height: " + height + ";";
}, function (_a) {
    var boxShadow = _a.boxShadow;
    return boxShadow && "box-shadow: -2px 5px 15px -2px #999;";
}, function (_a) {
    var fontFamily = _a.fontFamily;
    return fontFamily && "font-family: " + fontFamily + ";";
}, function (_a) {
    var center = _a.center;
    return center && "display: flex; justify-content: center; align-items: center;";
}, function (_a) {
    var centerHorizontal = _a.centerHorizontal;
    return centerHorizontal && "display: flex; justify-content: center;";
}, function (_a) {
    var border = _a.border;
    return border === "small" && "border: solid 1px;";
}, function (_a) {
    var border = _a.border;
    return border === "medium" && "border: solid 5px;";
}, function (_a) {
    var border = _a.border;
    return border === "large" && "border: solid 10px;";
}, function (_a) {
    var borderRadius = _a.borderRadius;
    return borderRadius && "border-radius: " + borderRadius + "px;";
}, function (_a) {
    var borderColor = _a.borderColor;
    return borderColor && "border-color: " + borderColor + ";";
}, function (_a) {
    var horizontalCenterMobile = _a.horizontalCenterMobile;
    return horizontalCenterMobile && "display: flex; justify-content: center;";
}, device.tablet, function (_a) {
    var horizontalCenterMobile = _a.horizontalCenterMobile;
    return horizontalCenterMobile && "display: flex; justify-content: initial;";
});
var Container = function (_a) {
    var padding = _a.padding, paddingLeft = _a.paddingLeft, paddingRight = _a.paddingRight, children = _a.children, backgroundColor = _a.backgroundColor, color = _a.color, width = _a.width, height = _a.height, boxShadow = _a.boxShadow, fontFamily = _a.fontFamily, center = _a.center, centerHorizontal = _a.centerHorizontal, borderRadius = _a.borderRadius, border = _a.border, borderColor = _a.borderColor, horizontalCenterMobile = _a.horizontalCenterMobile;
    return (React__default['default'].createElement(StyledContainer, { padding: padding, paddingLeft: paddingLeft, paddingRight: paddingRight, backgroundColor: backgroundColor, color: color, width: width, height: height, boxShadow: boxShadow, fontFamily: fontFamily, center: center, centerHorizontal: centerHorizontal, border: border, borderRadius: borderRadius, borderColor: borderColor, horizontalCenterMobile: horizontalCenterMobile, "data-testid": "container" }, children));
};
var templateObject_1$5;

var StyledGridContainer = styled__default['default'](Container)(templateObject_1$4 || (templateObject_1$4 = __makeTemplateObject(["\n    ", "\n"], ["\n    ", "\n"])), function (_a) {
    var order = _a.order;
    return order && "order: " + order + ";";
});
var GridContainer$1 = function (_a) {
    var children = _a.children, order = _a.order;
    return React__default['default'].createElement(StyledGridContainer, { order: order }, children);
};
var templateObject_1$4;

var StyledSpacer = styled__default['default'].div(templateObject_1$3 || (templateObject_1$3 = __makeTemplateObject(["\n  ", "\n"], ["\n  ", "\n"])), function (_a) {
    var height = _a.height;
    return height && "margin-bottom: " + height + "px;";
});
var Spacer = function (_a) {
    var height = _a.height;
    return React__default['default'].createElement(StyledSpacer, { height: height, "data-testid": "spacer" });
};
var templateObject_1$3;

var StyledCopy = styled__default['default'].p(templateObject_1$2 || (templateObject_1$2 = __makeTemplateObject(["\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n"], ["\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n"])), function (_a) {
    var fontFamily = _a.fontFamily;
    return fontFamily && "font-family: " + fontFamily + ";";
}, function (_a) {
    var color = _a.color;
    return color && "color: " + color + ";";
}, function (_a) {
    var italic = _a.italic;
    return italic && "font-style: italic;";
}, function (_a) {
    var fontWeight = _a.fontWeight;
    return fontWeight && "font-weight: " + fontWeight + ";";
}, function (_a) {
    var fontSize = _a.fontSize;
    return fontSize && "font-size: " + px2rem(fontSize) + ";";
}, function (_a) {
    var lineHeight = _a.lineHeight;
    return lineHeight && "line-height: " + px2rem(lineHeight) + ";";
}, function (_a) {
    var letterSpacing = _a.letterSpacing;
    return letterSpacing && "letter-spacing: " + px2rem(letterSpacing) + ";";
});
var Copy = function (_a) {
    var children = _a.children, fontFamily = _a.fontFamily, color = _a.color, italic = _a.italic, fontWeight = _a.fontWeight, fontSize = _a.fontSize, letterSpacing = _a.letterSpacing, lineHeight = _a.lineHeight;
    return (React__default['default'].createElement(StyledCopy, { fontFamily: fontFamily, color: color, italic: italic, fontWeight: fontWeight, fontSize: fontSize, letterSpacing: letterSpacing, lineHeight: lineHeight, "data-testid": "copyContent" }, children));
};
var templateObject_1$2;

var StyledHeader = styled__default['default'].span(templateObject_1$1 || (templateObject_1$1 = __makeTemplateObject(["\n  font-weight: normal;\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n"], ["\n  font-weight: normal;\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n"])), function (_a) {
    var fontFamily = _a.fontFamily;
    return fontFamily && "font-family: " + fontFamily + ";";
}, function (_a) {
    var color = _a.color;
    return color && "color: " + color + ";";
}, function (_a) {
    var italic = _a.italic;
    return italic && "font-style: italic;";
}, function (_a) {
    var fontWeight = _a.fontWeight;
    return fontWeight && "font-weight: " + fontWeight + ";";
}, function (_a) {
    var fontSize = _a.fontSize;
    return fontSize && "font-size: " + px2rem(fontSize) + ";";
}, function (_a) {
    var letterSpacing = _a.letterSpacing;
    return letterSpacing && "letter-spacing: " + px2rem(letterSpacing) + ";";
});
var BaseHeader = function (_a) {
    var level = _a.level, children = _a.children;
    return React.createElement("h" + level, {
        "data-testid": "header",
    }, children);
};
var Header = function (_a) {
    var level = _a.level, children = _a.children, fontFamily = _a.fontFamily, color = _a.color, italic = _a.italic, fontWeight = _a.fontWeight, fontSize = _a.fontSize, letterSpacing = _a.letterSpacing;
    return (React__default['default'].createElement(BaseHeader, { level: level || 1 },
        React__default['default'].createElement(StyledHeader, { fontFamily: fontFamily, color: color, italic: italic, fontWeight: fontWeight, fontSize: fontSize, letterSpacing: letterSpacing, "data-testid": "headerContent" }, children)));
};
var templateObject_1$1;

var GridContainer = styled__default['default'].div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  display: flex;\n  ", "\n"], ["\n  display: flex;\n  ", "\n"])), function (_a) {
    var wrap = _a.wrap;
    return wrap && "flex-wrap: wrap;";
});
var GridCol = styled__default['default'].div(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  flex-basis: 100%;\n  ", ";\n  ", ";\n  \n\n  @media ", " {\n    ", ";\n  }\n"], ["\n  flex-basis: 100%;\n  ", ";\n  ", ";\n  \n\n  @media ", " {\n    ", ";\n  }\n"])), function (_a) {
    var mobileColumns = _a.mobileColumns;
    return mobileColumns && "flex-basis: " + getFlexBasis(mobileColumns) + "%;";
}, function (_a) {
    var order = _a.order;
    return order && "order: " + order;
}, device.tablet, function (_a) {
    var columns = _a.columns;
    return columns && "flex-basis: " + getFlexBasis(columns) + "%;";
});
var getFlexBasis = function (columns) {
    return 100 / columns;
};
var Grid = function (_a) {
    var children = _a.children, columns = _a.columns, mobileColumns = _a.mobileColumns, wrap = _a.wrap;
    if (!children)
        return null;
    return (React__default['default'].createElement(GridContainer, { wrap: wrap, "data-testid": "grid" }, React__default['default'].Children.map(children, function (Child, i) {
        var order = children[i].props['order'];
        return (React__default['default'].createElement(GridCol, { columns: columns, mobileColumns: mobileColumns, order: order && order, "data-testid": "gridColumn" }, Child));
    })));
};
var templateObject_1, templateObject_2;

exports.Button = Button;
exports.Container = Container;
exports.Copy = Copy;
exports.Grid = Grid;
exports.GridContainer = GridContainer$1;
exports.Header = Header;
exports.Spacer = Spacer;
//# sourceMappingURL=index.js.map
